(***********************************************************************)
(*                                                                     *)
(*                         Fast Escape Analysis                        *)
(*                                                                     *)
(*                  Bruno Blanchet, ENS Ulm - INRIA Rocquencourt       *)
(*                                                                     *)
(*  Copyright 1995 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

module TEnv =
struct

  type t_env = int (*IdentInfo.t*) Ident.tbl

  type t_typedecl = int (*NewType.t_type_declaration*) Ident.tbl

  type t_hierarchy = {env : t_env;
                      types : t_typedecl;
                      submod : t_submodules;
                      submod_types: t_submodules}

  and t_hierarchy_mod = Module of t_hierarchy
                  | Functor of t_hierarchy_mod * t_hierarchy_mod
                        (* Pointer to the parameter environment * body
        The parameter environment will be changed when applying the functor *)

  and t_submodules = t_hierarchy_mod Ident.tbl

  let emptyhierarchy = {env = Ident.empty;
                        types = Ident.empty;
                        submod = Ident.empty;
                        submod_types = Ident.empty}

end
