(***********************************************************************)
(*                                                                     *)
(*                         Fast Escape Analysis                        *)
(*                                                                     *)
(*                  Bruno Blanchet, ENS Ulm - INRIA Rocquencourt       *)
(*                                                                     *)
(*  Copyright 1995 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(* $Id: l1envir.mli,v 1.1 1998/02/15 18:10:09 blanchet Exp $ *)

open L1env

module Envir :
  sig
    type t
    val create : unit -> t
    val startmodule : t -> t
    val add_module : Ident.t -> TEnv.t_hierarchy_mod -> t -> t
    val add_module_type : Ident.t -> TEnv.t_hierarchy_mod -> t -> t
    val update : Ident.t -> IdentInfo.t -> t -> t
    val add_type : Ident.t -> NewType.t_type_declaration -> t -> t
    val lookup_ident : Path.t -> t -> IdentInfo.t option
    val lookup_type : Path.t -> t -> NewType.t_type_declaration
    val lookup_module : Path.t -> t -> TEnv.t_hierarchy_mod
    val lookup_module_type : Path.t -> t -> TEnv.t_hierarchy_mod
    val set_escape_info : t -> unit
    val print : t -> unit
    val get_hierarchy : t -> TEnv.t_hierarchy_mod
  end
