(***********************************************************************)
(*                                                                     *)
(*                         Fast Escape Analysis                        *)
(*                                                                     *)
(*                  Bruno Blanchet, ENS Ulm - INRIA Rocquencourt       *)
(*                                                                     *)
(*  Copyright 1995 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(* $Id: tenvir.mli,v 1.2 1998/03/12 13:05:16 blanchet Exp $ *)

module Envir :
  sig
    type t
    val create : unit -> t
    val startmodule : t -> t
    val add_module : Ident.t -> Ttype.t_hierarchy_mod -> t -> t
    val add_module_type : Ident.t -> Ttype.t_hierarchy_mod -> t -> t
    val update : Ident.t -> Ttype.identinfo_t -> t -> t
    val add_type : Ident.t -> Ttype.t_type_declaration -> t -> t
    val lookup_ident : Path.t -> t -> Ttype.identinfo_t option
    val lookup_type : Path.t -> t -> Ttype.t_type_declaration
    val lookup_module : Path.t -> t -> Ttype.t_hierarchy_mod
    val lookup_module_type : Path.t -> t -> Ttype.t_hierarchy_mod
    val set_escape_info : t -> unit
    val print : t -> unit
    val show_graphs : t -> unit
    val get_hierarchy : t -> Ttype.t_hierarchy_mod
  end
