(***********************************************************************)
(*                                                                     *)
(*                         Fast Escape Analysis                        *)
(*                                                                     *)
(*                  Bruno Blanchet, ENS Ulm - INRIA Rocquencourt       *)
(*                                                                     *)
(*  Copyright 1995 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

open Format

type t = NoAnal
       | AnalT of Ttype.t_hierarchy
       | AnalF of Fenv.TEnv.t_hierarchy
       | AnalL1 of L1env.TEnv.t_hierarchy
       | AnalL of Lenv.TEnv.t_hierarchy

let mess = fun () -> print_string
		"This module was analysed by another analyzer"

let fromT x = AnalT x

let toT = function NoAnal -> Ttype.emptyhierarchy
		 | AnalT x -> x
		 | _ -> Message.error "toT" mess

let fromF x = AnalF x

let toF = function NoAnal -> Fenv.TEnv.emptyhierarchy
                 | AnalF x -> x
                 | _ -> Message.error "toF" mess

let fromL1 x = AnalL1 x

let toL1 = function NoAnal -> L1env.TEnv.emptyhierarchy
                 | AnalL1 x -> x
                 | _ -> Message.error "toL1" mess

let fromL x = AnalL x

let toL = function NoAnal -> Lenv.TEnv.emptyhierarchy
                 | AnalL x -> x
                 | _ -> Message.error "toL" mess
