(***********************************************************************)
(*                                                                     *)
(*                         Fast Escape Analysis                        *)
(*                                                                     *)
(*                  Alain Deutsch, INRIA Rocquencourt                  *)
(*                                                                     *)
(*  Copyright 1995 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(* $Id: printtypedtree.mli,v 1.1 1998/02/15 18:16:09 blanchet Exp $ *)

(* Abstract interpretation aimed at replacing unlimited extend allocations
    with lifetime-explicit, stack allocations *)

val print: Typedtree.structure -> unit
val print_expression: Typedtree.expression -> Pretty.t
val print_pattern: Typedtree.pattern -> Pretty.t
val print_with_delimitors: ('a -> Pretty.t) -> (Pretty.t list) -> ('a list) -> Pretty.t list
val print_path: Path.t -> Pretty.t
val print_type_expr: Types.type_expr -> Pretty.t
